#include <stddef.h>
#include <stdint.h>
#include <stdarg.h>
#include "console_io.h"

#define MAX_PRINT_SIZE 256

int printk(char *string,...) {

	va_list ap;

	char buffer[MAX_PRINT_SIZE];
	char int_buffer[10];
	int int_pointer=0;

	int buffer_pointer=0;
	int i;
	int x;
	uint32_t hex;

	va_start(ap, string);

	while(1) {
		if (*string==0) break;

		if (*string=='%') {
			string++;
			if (*string=='d') {
				string++;
				x=va_arg(ap, int);
				int_pointer=9;
				do {
					int_buffer[int_pointer]=(x%10)+'0';
					int_pointer--;
					x/=10;
				} while(x!=0);
				for(i=int_pointer+1;i<10;i++) {
					buffer[buffer_pointer]=int_buffer[i];
					buffer_pointer++;
				}

			}
			else if (*string=='x') {
				string++;
				hex=va_arg(ap, uint32_t);
				int_pointer=9;
				do {
					if ((hex%16)<10) {
						int_buffer[int_pointer]=(hex%16)+'0';
					}
					else {
						int_buffer[int_pointer]=(hex%16)-10+'a';
					}
					int_pointer--;
					hex/=16;
				} while(hex!=0);
				for(i=int_pointer+1;i<10;i++) {
					buffer[buffer_pointer]=int_buffer[i];
					buffer_pointer++;
				}
			}
		}
		else {
			buffer[buffer_pointer]=*string;
			buffer_pointer++;
			string++;
		}
		if (buffer_pointer==MAX_PRINT_SIZE-1) break;
	}

	va_end(ap);

	console_write(buffer,buffer_pointer);

	return buffer_pointer;
}

#if 0

int main(int argc, char **argv) {


	printk("Hello %d %x World!\n",4321,0xdec25);

	return 0;
}

#endif
